package com.namasoft.modules.commonbasic.contracts.entities;

import com.namasoft.common.flatobjects.EntityReferenceData;
import com.namasoft.contracts.common.dtos.DTOLargeData;
import com.namasoft.contracts.common.dtos.MasterFileDTO;
import com.namasoft.modules.commonbasic.contracts.details.DTOCarCustodianLine;
import com.namasoft.modules.commonbasic.contracts.valueobjects.DTOInsuranceInfo;
import com.namasoft.modules.commonbasic.contracts.valueobjects.DTOLegalDoc;
import com.namasoft.modules.commonbasic.contracts.valueobjects.DTOSubsidiaryOwner;
import jakarta.xml.bind.annotation.XmlAccessType;
import jakarta.xml.bind.annotation.XmlAccessorType;
import jakarta.xml.bind.annotation.XmlRootElement;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
@SuppressWarnings("serial")
@XmlRootElement
@XmlAccessorType(XmlAccessType.PROPERTY)
public abstract class GeneratedDTOCar extends MasterFileDTO implements Serializable
{
	private BigDecimal price;
	private Boolean isAuthorized;
	private DTOInsuranceInfo insuranceInfo;
	private DTOLargeData attachment1;
	private DTOLargeData attachment2;
	private DTOLargeData attachment3;
	private DTOLargeData attachment4;
	private DTOLargeData attachment5;
	private DTOLargeData attachment;
	private DTOLargeData licenseCopy;
	private DTOLargeData opCardCopy;
	private DTOLegalDoc authorization;
	private DTOLegalDoc operationCard;
	private DTOLegalDoc ownerId;
	private DTOLegalDoc riderId;
	private DTOSubsidiaryOwner subsidiaryAccounts;
	private Date carExtraDate1;
	private Date carExtraDate2;
	private Date delegationLicenceDate;
	private Date lastCheckDate;
	private Date licenceEndDate;
	private Date licenceStartDate;
	private Date ownershipDate;
	private Date purchaseDate;
	private EntityReferenceData brand;
	private EntityReferenceData carModel;
	private EntityReferenceData carOwner;
	private EntityReferenceData custodian;
	private EntityReferenceData fixedAsset;
	private Integer numberOfPassangers;
	private Integer productionYear;
	private Integer runningKM;
	private List<DTOCarCustodianLine> lines = new ArrayList<DTOCarCustodianLine>();
	private String altCode;
	private String authorizationType;
	private String carEngineNumber;
	private String carNumber;
	private String carSerial;
	private String carStatus;
	private String carStructNumber;
	private String carType;
	private String classification;
	private String color;
	private String description10;
	private String description6;
	private String description7;
	private String description8;
	private String description9;
	private String englishCarNumber;
	private String licenseState;
	private String opCardPlaceOfIssue;
	private String ownership;
	private String taxAuthorityCode;
	public BigDecimal getPrice()
	{
		return price;
	}

	public Boolean getIsAuthorized()
	{
		return isAuthorized;
	}

	public DTOInsuranceInfo getInsuranceInfo()
	{
		return insuranceInfo;
	}

	public DTOLargeData getAttachment()
	{
		return attachment;
	}

	public DTOLargeData getAttachment1()
	{
		return attachment1;
	}

	public DTOLargeData getAttachment2()
	{
		return attachment2;
	}

	public DTOLargeData getAttachment3()
	{
		return attachment3;
	}

	public DTOLargeData getAttachment4()
	{
		return attachment4;
	}

	public DTOLargeData getAttachment5()
	{
		return attachment5;
	}

	public DTOLargeData getLicenseCopy()
	{
		return licenseCopy;
	}

	public DTOLargeData getOpCardCopy()
	{
		return opCardCopy;
	}

	public DTOLegalDoc getAuthorization()
	{
		return authorization;
	}

	public DTOLegalDoc getOperationCard()
	{
		return operationCard;
	}

	public DTOLegalDoc getOwnerId()
	{
		return ownerId;
	}

	public DTOLegalDoc getRiderId()
	{
		return riderId;
	}

	public DTOSubsidiaryOwner getSubsidiaryAccounts()
	{
		return subsidiaryAccounts;
	}

	public Date getCarExtraDate1()
	{
		return carExtraDate1;
	}

	public Date getCarExtraDate2()
	{
		return carExtraDate2;
	}

	public Date getDelegationLicenceDate()
	{
		return delegationLicenceDate;
	}

	public Date getLastCheckDate()
	{
		return lastCheckDate;
	}

	public Date getLicenceEndDate()
	{
		return licenceEndDate;
	}

	public Date getLicenceStartDate()
	{
		return licenceStartDate;
	}

	public Date getOwnershipDate()
	{
		return ownershipDate;
	}

	public Date getPurchaseDate()
	{
		return purchaseDate;
	}

	public EntityReferenceData getBrand()
	{
		return brand;
	}

	public EntityReferenceData getCarModel()
	{
		return carModel;
	}

	public EntityReferenceData getCarOwner()
	{
		return carOwner;
	}

	public EntityReferenceData getCustodian()
	{
		return custodian;
	}

	public EntityReferenceData getFixedAsset()
	{
		return fixedAsset;
	}

	public Integer getNumberOfPassangers()
	{
		return numberOfPassangers;
	}

	public Integer getProductionYear()
	{
		return productionYear;
	}

	public Integer getRunningKM()
	{
		return runningKM;
	}

	public List<DTOCarCustodianLine> getLines()
	{
		return lines;
	}

	public String getAltCode()
	{
		return altCode;
	}

	public String getAuthorizationType()
	{
		return authorizationType;
	}

	public String getCarEngineNumber()
	{
		return carEngineNumber;
	}

	public String getCarNumber()
	{
		return carNumber;
	}

	public String getCarSerial()
	{
		return carSerial;
	}

	public String getCarStatus()
	{
		return carStatus;
	}

	public String getCarStructNumber()
	{
		return carStructNumber;
	}

	public String getCarType()
	{
		return carType;
	}

	public String getClassification()
	{
		return classification;
	}

	public String getColor()
	{
		return color;
	}

	public String getDescription10()
	{
		return description10;
	}

	public String getDescription6()
	{
		return description6;
	}

	public String getDescription7()
	{
		return description7;
	}

	public String getDescription8()
	{
		return description8;
	}

	public String getDescription9()
	{
		return description9;
	}

	public String getEnglishCarNumber()
	{
		return englishCarNumber;
	}

	public String getLicenseState()
	{
		return licenseState;
	}

	public String getOpCardPlaceOfIssue()
	{
		return opCardPlaceOfIssue;
	}

	public String getOwnership()
	{
		return ownership;
	}

	public String getTaxAuthorityCode()
	{
		return taxAuthorityCode;
	}

	public void setAltCode(String altCode)
	{
		this.altCode = altCode;
	}

	public void setAttachment(DTOLargeData attachment)
	{
		this.attachment = attachment;
	}

	public void setAttachment1(DTOLargeData attachment1)
	{
		this.attachment1 = attachment1;
	}

	public void setAttachment2(DTOLargeData attachment2)
	{
		this.attachment2 = attachment2;
	}

	public void setAttachment3(DTOLargeData attachment3)
	{
		this.attachment3 = attachment3;
	}

	public void setAttachment4(DTOLargeData attachment4)
	{
		this.attachment4 = attachment4;
	}

	public void setAttachment5(DTOLargeData attachment5)
	{
		this.attachment5 = attachment5;
	}

	public void setAuthorization(DTOLegalDoc authorization)
	{
		this.authorization = authorization;
	}

	public void setAuthorizationType(String authorizationType)
	{
		this.authorizationType = authorizationType;
	}

	public void setBrand(EntityReferenceData brand)
	{
		this.brand = brand;
	}

	public void setCarEngineNumber(String carEngineNumber)
	{
		this.carEngineNumber = carEngineNumber;
	}

	public void setCarExtraDate1(Date carExtraDate1)
	{
		this.carExtraDate1 = carExtraDate1;
	}

	public void setCarExtraDate2(Date carExtraDate2)
	{
		this.carExtraDate2 = carExtraDate2;
	}

	public void setCarModel(EntityReferenceData carModel)
	{
		this.carModel = carModel;
	}

	public void setCarNumber(String carNumber)
	{
		this.carNumber = carNumber;
	}

	public void setCarOwner(EntityReferenceData carOwner)
	{
		this.carOwner = carOwner;
	}

	public void setCarSerial(String carSerial)
	{
		this.carSerial = carSerial;
	}

	public void setCarStatus(String carStatus)
	{
		this.carStatus = carStatus;
	}

	public void setCarStructNumber(String carStructNumber)
	{
		this.carStructNumber = carStructNumber;
	}

	public void setCarType(String carType)
	{
		this.carType = carType;
	}

	public void setClassification(String classification)
	{
		this.classification = classification;
	}

	public void setColor(String color)
	{
		this.color = color;
	}

	public void setCustodian(EntityReferenceData custodian)
	{
		this.custodian = custodian;
	}

	public void setDelegationLicenceDate(Date delegationLicenceDate)
	{
		this.delegationLicenceDate = delegationLicenceDate;
	}

	public void setDescription10(String description10)
	{
		this.description10 = description10;
	}

	public void setDescription6(String description6)
	{
		this.description6 = description6;
	}

	public void setDescription7(String description7)
	{
		this.description7 = description7;
	}

	public void setDescription8(String description8)
	{
		this.description8 = description8;
	}

	public void setDescription9(String description9)
	{
		this.description9 = description9;
	}

	public void setEnglishCarNumber(String englishCarNumber)
	{
		this.englishCarNumber = englishCarNumber;
	}

	public void setFixedAsset(EntityReferenceData fixedAsset)
	{
		this.fixedAsset = fixedAsset;
	}

	public void setInsuranceInfo(DTOInsuranceInfo insuranceInfo)
	{
		this.insuranceInfo = insuranceInfo;
	}

	public void setIsAuthorized(Boolean isAuthorized)
	{
		this.isAuthorized = isAuthorized;
	}

	public void setLastCheckDate(Date lastCheckDate)
	{
		this.lastCheckDate = lastCheckDate;
	}

	public void setLicenceEndDate(Date licenceEndDate)
	{
		this.licenceEndDate = licenceEndDate;
	}

	public void setLicenceStartDate(Date licenceStartDate)
	{
		this.licenceStartDate = licenceStartDate;
	}

	public void setLicenseCopy(DTOLargeData licenseCopy)
	{
		this.licenseCopy = licenseCopy;
	}

	public void setLicenseState(String licenseState)
	{
		this.licenseState = licenseState;
	}

	public void setLines(List<DTOCarCustodianLine> lines)
	{
		this.lines = lines;
	}

	public void setNumberOfPassangers(Integer numberOfPassangers)
	{
		this.numberOfPassangers = numberOfPassangers;
	}

	public void setOpCardCopy(DTOLargeData opCardCopy)
	{
		this.opCardCopy = opCardCopy;
	}

	public void setOpCardPlaceOfIssue(String opCardPlaceOfIssue)
	{
		this.opCardPlaceOfIssue = opCardPlaceOfIssue;
	}

	public void setOperationCard(DTOLegalDoc operationCard)
	{
		this.operationCard = operationCard;
	}

	public void setOwnerId(DTOLegalDoc ownerId)
	{
		this.ownerId = ownerId;
	}

	public void setOwnership(String ownership)
	{
		this.ownership = ownership;
	}

	public void setOwnershipDate(Date ownershipDate)
	{
		this.ownershipDate = ownershipDate;
	}

	public void setPrice(BigDecimal price)
	{
		this.price = price;
	}

	public void setProductionYear(Integer productionYear)
	{
		this.productionYear = productionYear;
	}

	public void setPurchaseDate(Date purchaseDate)
	{
		this.purchaseDate = purchaseDate;
	}

	public void setRiderId(DTOLegalDoc riderId)
	{
		this.riderId = riderId;
	}

	public void setRunningKM(Integer runningKM)
	{
		this.runningKM = runningKM;
	}

	public void setSubsidiaryAccounts(DTOSubsidiaryOwner subsidiaryAccounts)
	{
		this.subsidiaryAccounts = subsidiaryAccounts;
	}

	public void setTaxAuthorityCode(String taxAuthorityCode)
	{
		this.taxAuthorityCode = taxAuthorityCode;
	}

}
